/**********************************************************************************
CH395 TCP/IP Эӿ
Socket0TCP ģʽʹ8Socketʾӹ
TMD Send from Rick and Morty using Interrupt!
**********************************************************************************/

/* ͷļ*/
#include "debug.h"
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/**********************************************************************************
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.H"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.H"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.H"

#define CH395_INT_WIRE    GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)    /* CH395INT# */

#define  CH395_DEBUG                1

#define  SocketNum                  8                                /*TCP SERVER ֵ֧Socket(SocketNum -1)*/
#define  TcpMss                     536                              /*TCPMSS*/

#define DEF_KEEP_LIVE_IDLE                           (15*1000)       /* ʱ */
#define DEF_KEEP_LIVE_PERIOD                         (20*1000)       /* Ϊ15룬һKEEPLIVEݰ */
#define DEF_KEEP_LIVE_CNT                             200             /* Դ  */

/* ñ */
UINT8  MyBuffer[SocketNum-1][TcpMss*2];                              /* ݻ */
struct _SOCK_INF  SockInf;                                           /* SocketϢ */
struct _CH395_SYS CH395Inf;                                          /* CH395Ϣ */

/* CH395ض */
const UINT8 CH395IPAddr[4] = {192,168,22,100};                        /* CH395IPַ */
const UINT8 CH395GWIPAddr[4] = {192,168,22,1};                        /* CH395 */
const UINT8 CH395IPMask[4] = {255,255,255,0};                        /* CH395 */

/* socket ض*/
const UINT16 Socket0SourPort = 5000;                                 /* Socket 0Դ˿ */

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 )
    {
        Delay_Ms(200);
        Delay_Ms(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf,0,sizeof(SockInf));                              /* SockInf[0]ȫ*/
    SockInf.SourPort = Socket0SourPort;                              /* Դ˿ */
    SockInf.ProtoType = PROTO_TYPE_TCP;                              /* TCPģʽ */
    SockInf.TcpMode = TCP_SERVER_MODE;
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪTCP ģʽ          */
    CH395SetSocketProtType(0,SockInf.ProtoType);                     /* socket 0Э */
    CH395SetSocketSourPort(0,SockInf.SourPort);                      /* socket 0Դ˿ */

    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);                                                 /*  */

    i = CH395TCPListen(0);                                           /* TCP */
    mStopIfError(i);                                                 /* Ƿɹ */

    for(i=1;i<SocketNum;i++)
    {
      CH395SetSocketProtType(i,SockInf.ProtoType);                     /* socket Э */
      CH395SetSocketSourPort(i,SockInf.SourPort);                      /* socket Դ˿ */
    }
}



/*********************************************************************************
* Function Name  : keeplive_set
* Description    : ʱ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void keeplive_set(void)
{
	CH395KeepLiveCNT(DEF_KEEP_LIVE_CNT);
	CH395KeepLiveIDLE(DEF_KEEP_LIVE_IDLE);
	CH395KeepLiveINTVL(DEF_KEEP_LIVE_PERIOD);
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
   UINT8  sock_int_socket;
//   UINT8  i;
   UINT16 len;
   UINT16 tmp;
   UINT8  buf[10];

   UINT8 Buffer[]="TMD Send from Rick and Morty using Interrupt!";
   UINT8 Buf[2];

   sock_int_socket = CH395GetSocketInt(sockindex);                   /* ȡsocket ж״̬ */
   if(sock_int_socket & SINT_STAT_SENBUF_FREE)                       /* ͻУԼдҪ͵ */
   {

   }
   if(sock_int_socket & SINT_STAT_SEND_OK)                           /* ж */
   {
   }
   if(sock_int_socket & SINT_STAT_RECV)                              /* ж */
   {
       len = CH395GetRecvLength(sockindex);                          /* ȡǰݳ */
#if CH395_DEBUG
       printf("receive len = %d\n",len);
#endif
       if(len == 0)return;
       if(len > 512)len = 512;                                       /* MyBufferΪ512 */
       CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);                     /* ȡ */
       CH395SendData(sockindex,MyBuffer[sockindex],len);
    }
	if(sock_int_socket & SINT_STAT_CONNECT)                          /* жϣTCPģʽЧ*/
	{
//		CH395SetKeepLive(sockindex,1);								 /*KEEPALIVEʱ*/
//		CH395SetTTLNum(sockindex,40); 								 /*TTL*/

#if CH395_DEBUG
       printf("Tcp Connect\n");
#endif
       if(SockInf.TcpMode == TCP_SERVER_MODE)                       /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
       {
            CH395CMDGetRemoteIPP(sockindex,buf);
            tmp = (UINT16)(buf[5]<<8) + buf[4];
            printf("Port = %x\n",tmp);

            CH395CMDGetSocketStatus(sockindex,Buf);                 /* ȡǰݳ */
            printf("1Socket״̬%x\n",Buf[0]);
            printf("2Socket״̬%x\n",Buf[1]);
            len = 512;                                 /* MyBufferΪ512 */
            printf("3ȣ%x\n",len);
            if(Buf[1] == 0x04)
            {
                CH395SendData(sockindex,Buffer,len);
            }
#if CH395_DEBUG
           printf("IP address = %d.%d.%d.%d\n",(UINT16)buf[0],(UINT16)buf[1],(UINT16)buf[2],(UINT16)buf[3]);
           printf("Port = %d\n",tmp);
#endif
       }
	}
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
	if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
	{
	    printf("Ͽж \n");
//	    i = CH395CloseSocket(sockindex);
//        mStopIfError(i);
//        Delay_Ms(2);
//        i = CH395OpenSocket(sockindex);
//        mStopIfError(i);
	}
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱж */
   {
		printf("ʱж \n");
//		i = CH395CloseSocket(sockindex);
//        mStopIfError(i);
//        Delay_Ms(2);
//        i = CH395OpenSocket(sockindex);
//        mStopIfError(i);
   }
}

/**********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395GlobalInterrupt(void)
{
   UINT16  init_status;
   UINT8   buf[10];

    init_status = CH395CMDGetGlobIntStatus_ALL();
    printf("1111Init status : %x\n");
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif

    }
    if(init_status & GINT_STAT_SOCK0)
    {
        printf("socket 0\n");
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)
    {
        printf("socket 1\n");
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)
    {
        printf("socket 2\n");
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)
    {
        printf("socket 3\n");
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        printf("socket 4\n");
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)
    {
        printf("socket 5\n");
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)
    {
        printf("socket 6\n");
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)
    {
        printf("socket 7\n");
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/*********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;

    i = CH395CMDCheckExist(0x65);
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 2)
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */
    Delay_Ms(1);
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/
    CH395SetStartPara(FUN_PARA_FLAG_TCP_SERVER);
//    CH395SetStartPara(1<<5);
    Delay_Ms(10);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/*********************************************************************************
* Function Name  : Socket_R_S_Buf_Modify
* Description    : Socketշ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void Socket_R_S_Buf_Modify(void )
{

   CH395SetSocketRecvBuf(0,0,4);                                     /* Socket 0 ջ4*512 = 2Kͻ2*512 = 1K*/
   CH395SetSocketSendBuf(0,4,2);

   CH395SetSocketRecvBuf(1,6,4);                                     /* Socket 1 */
   CH395SetSocketSendBuf(1,10,2);

   CH395SetSocketRecvBuf(2,12,4);                                    /* Socket 2 */
   CH395SetSocketSendBuf(2,16,2);

   CH395SetSocketRecvBuf(3,18,4);                                    /* Socket 3 */
   CH395SetSocketSendBuf(3,22,2);

   CH395SetSocketRecvBuf(4,24,4);                                    /* Socket 4 */
   CH395SetSocketSendBuf(4,28,2);

   CH395SetSocketRecvBuf(5,30,4);                                    /* Socket 5 */
   CH395SetSocketSendBuf(5,34,2);

   CH395SetSocketRecvBuf(6,36,4);                                    /* Socket 6 */
   CH395SetSocketSendBuf(6,40,2);

   CH395SetSocketRecvBuf(7,42,4);                                    /* Socket 7 */
   CH395SetSocketSendBuf(7,46,2);

}
/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/

int main(void)
{
    UINT8 i;

    Delay_Init();
    USART_Printf_Init(115200);
    printf("0000\n");
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();                                               /* ʼƬ */
    CH395CMDReset();                                                 /* λCH395оƬ */
    Delay_Ms(1000);                                                  /* ʱ1000,ҪֿдЧ */
    Delay_Ms(1000);
    i = CH395CMDGetVer();                                            /*ȡоƬԼ̼汾 */
    if(i < 0x44)                                                     /* TCP SERVERģʽ0X44ϰ汾֧֣0x44°汾TCP SERVERֻ֧һ */
    {
#if CH395_DEBUG
    printf("Error: Not Support!\n");                                /* ʾ */
#endif
        while ( 1 )
        {
            Delay_Ms(200);
            Delay_Ms(200);
        }
    }
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);                                                 /*ʹãʾ룬ͣ*/
	printf("8888\n");
	Socket_R_S_Buf_Modify();                                         /* Socketͺͽջ*/
    CH395SetTCPMss(TcpMss);                                          /* TCPMSS*/
	while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           Delay_Ms(200);                                            /* δȴ200MSٴβѯ */
       }
       else
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
	InitSocketParam();                                               /* ʼsocketر */
	CH395SocketInitOpen();
	printf("9999\n");
	while(1)
	{
	    if(CH395_INT_WIRE==RESET)                                    /* жŵƽ仯ȫж */
		{
	        CH395GlobalInterrupt();
		}
	}
}

